AppDomain.UnhandledException AppDomain.UnhandledException AppDomain.UnhandledException AppDomain.UnhandledException Event

Definition

Se produce cuando no se detecta una excepción. Occurs when an exception is not caught.

public:
 virtual event UnhandledExceptionEventHandler ^ UnhandledException;
[add: System.Security.SecurityCritical]
[remove: System.Security.SecurityCritical]
public event UnhandledExceptionEventHandler UnhandledException;
member this.UnhandledException : UnhandledExceptionEventHandler 
Public Custom Event UnhandledException As UnhandledExceptionEventHandler 

Implements

Attributes

Examples

El siguiente ejemplo se muestra el UnhandledException eventos.The followingexample demonstrates the UnhandledException event. Define un controlador de eventos, MyHandler, que se invoca cuando se produce una excepción no controlada en el dominio de aplicación predeterminado.It defines an event handler, MyHandler, that is invoked whenever an unhandled exception is thrown in the default application domain. A continuación, se produce dos excepciones.It then throws two exceptions. La primera se controla mediante un try/catch bloque.The first is handled by a try/catch block. El segundo es controlado y se invoca el MyHandle rutina antes de que termine la aplicación.The second is unhandled and invokes the MyHandle routine before the application terminates.

// The example should be compiled with the /clr:pure compiler option.
using namespace System;
using namespace System::Security::Permissions;

public ref class Example
{


private:
   static void MyHandler(Object^ sender, UnhandledExceptionEventArgs^ args)
   {
      Exception^ e = dynamic_cast<Exception^>(args->ExceptionObject);
      Console::WriteLine( "MyHandler caught : {0}", e->Message );
      Console::WriteLine("Runtime terminating: {0}", args->IsTerminating);
   }
   
public: 
   [SecurityPermissionAttribute( SecurityAction::Demand, ControlAppDomain = true )]
   static void Main()
   {
      AppDomain^ currentDomain = AppDomain::CurrentDomain;
      currentDomain->UnhandledException += gcnew UnhandledExceptionEventHandler(Example::MyHandler);
      try
      {
         throw gcnew Exception("1");
      }
      catch (Exception^ e) 
      {
         Console::WriteLine( "Catch clause caught : {0}\n", e->Message );
      }

      throw gcnew Exception("2");
   }
};

void main()
{
   Example::Main();
}   
// The example displays the following output:
//       Catch clause caught : 1
//       
//       MyHandler caught : 2
//       Runtime terminating: True
//       
//       Unhandled Exception: System.Exception: 2
//          at Example.Main()
//          at mainCRTStartup(String[] arguments)
using System;
using System.Security.Permissions;

public class Example 
{
   [SecurityPermission(SecurityAction.Demand, Flags=SecurityPermissionFlag.ControlAppDomain)]
   public static void Main()
   {
      AppDomain currentDomain = AppDomain.CurrentDomain;
      currentDomain.UnhandledException += new UnhandledExceptionEventHandler(MyHandler);
      
      try {
         throw new Exception("1");
      } catch (Exception e) {
         Console.WriteLine("Catch clause caught : {0} \n", e.Message);
      }

      throw new Exception("2");
   }
   
   static void MyHandler(object sender, UnhandledExceptionEventArgs args) 
   {
      Exception e = (Exception) args.ExceptionObject;
      Console.WriteLine("MyHandler caught : " + e.Message);
      Console.WriteLine("Runtime terminating: {0}", args.IsTerminating);
   }
}
// The example displays the following output:
//       Catch clause caught : 1
//       
//       MyHandler caught : 2
//       Runtime terminating: True
//       
//       Unhandled Exception: System.Exception: 2
//          at Example.Main()  
Module Example
   Sub Main()
      Dim currentDomain As AppDomain = AppDomain.CurrentDomain
      AddHandler currentDomain.UnhandledException, AddressOf MyHandler
      
      Try
         Throw New Exception("1")
      Catch e As Exception
         Console.WriteLine("Catch clause caught : " + e.Message)
         Console.WriteLine()
      End Try
      
      Throw New Exception("2")
   End Sub
   
   Sub MyHandler(sender As Object, args As UnhandledExceptionEventArgs)
      Dim e As Exception = DirectCast(args.ExceptionObject, Exception)
      Console.WriteLine("MyHandler caught : " + e.Message)
      Console.WriteLine("Runtime terminating: {0}", args.IsTerminating)
   End Sub
End Module
' The example displays the following output:
'       Catch clause caught : 1
'       
'       MyHandler caught : 2
'       Runtime terminating: True
'       
'       Unhandled Exception: System.Exception: 2
'          at Example.Main()

Remarks

Este evento proporciona una notificación de excepciones no detectadas.This event provides notification of uncaught exceptions. Permite que la aplicación registrar información sobre la excepción antes de que el controlador predeterminado del sistema notifica la excepción al usuario y finaliza la aplicación.It allows the application to log information about the exception before the system default handler reports the exception to the user and terminates the application. Si hay suficiente información sobre el estado de la aplicación, se pueden llevar a cabo otras acciones, como guardar datos del programa para su posterior recuperación.If sufficient information about the state of the application is available, other actions may be undertaken — such as saving program data for later recovery. Precaución, porque los datos de programa pueden dañarse cuando no se controlan las excepciones.Caution is advised, because program data can become corrupted when exceptions are not handled.

Nota

En las versiones 1.0 y 1.1 de .NET Framework, opciones de depuración y de finalización de la aplicación se notifican al usuario antes de que se genera este evento, en lugar de después.In the .NET Framework versions 1.0 and 1.1, application termination and debugging options are reported to the user before this event is raised, rather than after.

Este evento se puede controlar en cualquier dominio de aplicación.This event can be handled in any application domain. Sin embargo, el evento no se genera necesariamente en el dominio de aplicación donde se produjo la excepción.However, the event is not necessarily raised in the application domain where the exception occurred. Una excepción es no controlada solo si se ha quitado toda la pila del subproceso sin encontrar un controlador de excepciones es aplicable, por lo que es el primer lugar que el evento puede generarse en el dominio de aplicación donde se originó el subproceso.An exception is unhandled only if the entire stack for the thread has been unwound without finding an applicable exception handler, so the first place the event can be raised is in the application domain where the thread originated.

Nota

En las versiones 1.0 y 1.1 de .NET Framework, este evento se produce solo en el dominio de aplicación predeterminado creado por el sistema cuando se inicia una aplicación.In the .NET Framework versions 1.0 and 1.1, this event occurs only for the default application domain that is created by the system when an application is started. Si una aplicación crea dominios de aplicación adicionales, especificando a un delegado para este evento en dichos dominios de aplicación no tiene ningún efecto.If an application creates additional application domains, specifying a delegate for this event in those applications domains has no effect.

Si el UnhandledException evento se controla en el dominio de aplicación predeterminado, se producirá allí para cualquier excepción no controlada en cualquier subproceso, independientemente de qué dominio de aplicación la ha iniciado el subproceso.If the UnhandledException event is handled in the default application domain, it is raised there for any unhandled exception in any thread, no matter what application domain the thread started in. Si se ha iniciado el subproceso en un dominio de aplicación que tiene un controlador de eventos UnhandledException, se genera el evento en ese dominio de aplicación.If the thread started in an application domain that has an event handler for UnhandledException, the event is raised in that application domain. Si ese dominio de aplicación no es el dominio de aplicación predeterminado, y también hay un controlador de eventos en el dominio de aplicación predeterminado, el evento se produce en dos dominios de aplicación.If that application domain is not the default application domain, and there is also an event handler in the default application domain, the event is raised in both application domains.

Por ejemplo, supongamos que un subproceso se inicia en el dominio de aplicación "AD1", llama a un método en el dominio de aplicación "AD2" y, a partir de ahí llama a un método en el dominio de aplicación "AD3", donde produce una excepción.For example, suppose a thread starts in application domain "AD1", calls a method in application domain "AD2", and from there calls a method in application domain "AD3", where it throws an exception. El primer dominio de aplicación en el que el UnhandledException puede generarse el evento es "AD1".The first application domain in which the UnhandledException event can be raised is "AD1". Si ese dominio de aplicación no es el dominio de aplicación predeterminado, también se provoca el evento en el dominio de aplicación predeterminado.If that application domain is not the default application domain, the event can also be raised in the default application domain.

Nota

Common language runtime suspende las anulaciones de subproceso mientras los controladores de eventos para el UnhandledException eventos se ejecutan.The common language runtime suspends thread aborts while event handlers for the UnhandledException event are executing.

Si el controlador de eventos tiene un ReliabilityContractAttribute atributo con las marcas apropiadas, el controlador de eventos se trata como una región de ejecución restringida.If the event handler has a ReliabilityContractAttribute attribute with the appropriate flags, the event handler is treated as a constrained execution region.

A partir de la .NET Framework 4.NET Framework 4, no se provoca este evento para las excepciones que se dañan el estado del proceso, como desbordamientos de pila o infracciones de acceso, a menos que el controlador de eventos es crítico para la seguridad y tiene el HandleProcessCorruptedStateExceptionsAttribute atributo.Starting with the .NET Framework 4.NET Framework 4, this event is not raised for exceptions that corrupt the state of the process, such as stack overflows or access violations, unless the event handler is security-critical and has the HandleProcessCorruptedStateExceptionsAttribute attribute.

En las versiones 1.0 y 1.1 de .NET Framework, una excepción no controlada que se produce en un subproceso distinto del subproceso principal de la aplicación ha sido detectada por el tiempo de ejecución y, por tanto, no hace que la aplicación finalice.In the .NET Framework versions 1.0 and 1.1, an unhandled exception that occurs in a thread other than the main application thread is caught by the runtime and therefore does not cause the application to terminate. Por lo tanto, es posible que el UnhandledException evento sin la terminación de la aplicación.Thus, it is possible for the UnhandledException event to be raised without the application terminating. A partir de la versión 2.0 de .NET Framework, este mecanismo de seguridad para las excepciones no controladas en subprocesos secundarios se ha quitado, puesto que el efecto acumulativo de errores sin incluido una degradación del rendimiento, datos dañados y bloqueos, que eran difíciles depurar.Starting with the .NET Framework version 2.0, this backstop for unhandled exceptions in child threads was removed, because the cumulative effect of such silent failures included performance degradation, corrupted data, and lockups, all of which were difficult to debug. Para obtener más información, incluida una lista de los casos en los que no finaliza el tiempo de ejecución, consulte excepciones en subprocesos administrados.For more information, including a list of cases in which the runtime does not terminate, see Exceptions in Managed Threads.

Para registrar un controlador de eventos para este evento, debe tener los permisos necesarios, o un SecurityException se produce.To register an event handler for this event, you must have the required permissions, or a SecurityException is thrown.

Para obtener más información sobre el manejo de eventos, consulte controlar y provocar eventos.For more information about handling events, see Handling and Raising Events.

Otros eventos para las excepciones no controladasOther Events for Unhandled Exceptions

Para determinados modelos de aplicación, el UnhandledException evento puede ser adelantado por otros eventos si se produce la excepción no controlada en el subproceso principal de la aplicación.For certain application models, the UnhandledException event can be preempted by other events if the unhandled exception occurs in the main application thread.

En las aplicaciones que usan Windows Forms, excepciones no controladas en la causa del subproceso principal de la aplicación la Application.ThreadException evento.In applications that use Windows Forms, unhandled exceptions in the main application thread cause the Application.ThreadException event to be raised. Si se controla este evento, el comportamiento predeterminado es que la excepción no controlada finaliza la aplicación, aunque la aplicación se queda en un estado desconocido.If this event is handled, the default behavior is that the unhandled exception does not terminate the application, although the application is left in an unknown state. En ese caso, el UnhandledException no se produce el evento.In that case, the UnhandledException event is not raised. Este comportamiento puede modificarse mediante el archivo de configuración de aplicación, o mediante el uso de la Application.SetUnhandledExceptionMode método para cambiar el modo a UnhandledExceptionMode.ThrowException antes el ThreadException se enlazó el controlador de eventos.This behavior can be changed by using the application configuration file, or by using the Application.SetUnhandledExceptionMode method to change the mode to UnhandledExceptionMode.ThrowException before the ThreadException event handler is hooked up. Esto se aplica sólo al subproceso principal de la aplicación.This applies only to the main application thread. El UnhandledException evento se desencadena para excepciones no controladas producidas en otros subprocesos.The UnhandledException event is raised for unhandled exceptions thrown in other threads.

A partir de Microsoft Visual Studio 2005, el marco de aplicación de Visual Basic proporciona otro evento para las excepciones no controladas en el subproceso principal de la aplicación.Starting with Microsoft Visual Studio 2005, the Visual Basic application framework provides another event for unhandled exceptions in the main application thread. Consulte la WindowsFormsApplicationBase.UnhandledException eventos.See the WindowsFormsApplicationBase.UnhandledException event. Este evento tiene un objeto de argumentos de evento con el mismo nombre que el objeto de argumentos de evento utilizado por AppDomain.UnhandledException, pero con diferentes propiedades.This event has an event arguments object with the same name as the event arguments object used by AppDomain.UnhandledException, but with different properties. En concreto, este objeto de argumentos de evento tiene un ExitApplication propiedad que permite que la aplicación continuar la ejecución, se omitirá la excepción no controlada (y dejar la aplicación en un estado desconocido).In particular, this event arguments object has an ExitApplication property that allows the application to continue running, ignoring the unhandled exception (and leaving the application in an unknown state). En ese caso, el AppDomain.UnhandledException no se produce el evento.In that case, the AppDomain.UnhandledException event is not raised.

Security

SecurityCriticalAttribute
requiere plena confianza para el llamador inmediato. requires full trust for the immediate caller. Este miembro no se puede usar código de confianza parcial o transparente. This member cannot be used by partially trusted or transparent code.

Applies to